/*-------------------------------------------------------------------
 Description: Simpe TCP Server Example
 Filename: main.cpp
 -------------------------------------------------------------------*/
#include "predef.h" 
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <dhcpclient.h>
#include <netinterface.h>
#include <tcp.h>

#define TCP_LISTEN_PORT	23   // Telent port number
#define RX_BUFSIZE (4096)

//----- Global Vars -----
char RXBuffer[RX_BUFSIZE];

extern "C" { 
void UserMain(void * pd);
}

const char * AppName="TCPSrv-NBSimple";


/*-------------------------------------------------------------------
 Convert an IP address of type IPADDR to a string.
 Warning: make sure the output string s has enough storage!
 ------------------------------------------------------------------*/
void IPtoString(IPADDR  ia, char *s)
{
	PBYTE ipb= (PBYTE)&ia;
	siprintf(s, "%d.%d.%d.%d",(int)ipb[0],(int)ipb[1],(int)ipb[2],(int)ipb[3]);
}


/*-------------------------------------------------------------------
 ------------------------------------------------------------------*/
void UserMain(void * pd)
{
    InitializeStack();
    int EthernetInterface = GetFirstInterface();  // Get first interface identifier
    InterfaceBlock *ib = GetInterFaceBlock( EthernetInterface );  // Get interface data
    if (ib->netIP == 0)  // Check IP address for 0.0.0.0, and use DHCP if necessary
    {
       iprintf( "\r\nNo static IP address set, attempting DHCP\r\n");
       if ( GetDHCPAddress() != DHCP_OK )
          iprintf("*** DHCP Failed \r\n");
       else
          iprintf( "DHCP IP Address: ");
    }
    else
       iprintf("Static IP Address: ");
    ShowIP(ib->netIP); iprintf("\r\n");
    
    OSChangePrio(MAIN_PRIO);
    EnableAutoUpdate();
    StartHTTP();

    iprintf("Application started\r\n");
    iprintf("My IP Address is: "); ShowIP(EthernetIP);
    iprintf("\r\n");
    while (1)
    {
		// Set up the listening TCP socket
		int fdListen = listen(INADDR_ANY, TCP_LISTEN_PORT, 5);

		if (fdListen > 0)
		{
			IPADDR	client_addr;
			WORD	port;

			while(1)
			{
				/* Wait to accept incoming connection. Display debug messages to serial port.
				   When a connection is terminated, the application will come back to
				   this accept() call and wait for another connection.
	            */
				iprintf("Wainting for connection on port %d...\n", TCP_LISTEN_PORT);
				int fdnet = accept(fdListen, &client_addr, &port, 0);
				iprintf("Connected to: "); ShowIP(client_addr);
				iprintf(":%d\n", port);

				// Display sign-on message to connecting client
				writestring(fdnet, "Welcome to the NetBurner TCP Server\r\n");
				char s[20];
				IPtoString(EthernetIP, s);
				siprintf(RXBuffer, "You are connected to IP Address %s, port %d\r\n", s, TCP_LISTEN_PORT);
				writestring(fdnet, RXBuffer);

				/* Loop while connection is valid. The read() function will return
				   0 or a negative number if the client closes the connection, so we
				   test the return value in the loop.
				*/
                int n = 0;
				do {
					n = read(fdnet, RXBuffer, RX_BUFSIZE);
					RXBuffer[n] = '\0';
					iprintf("Read %d bytes: %s\n", n, RXBuffer);
				} while (n > 0);

				// Don't foreget to close !
				close(fdnet);
			}
		}
	}		
}

